# Validator performance

The `ValidatorPerformance` entity provides the validator performance score as the percentage of rewards received per one token relative to the maximum ratio received by a validator in the given era. A validator that received the highest ratio will have a 100 score.

The average performance endpoints return moving average of the validator performance for the past 360 eras (approximately one month).

## Properties

The `ValidatorPerformance` entity has the following properties:

| Property     | Type         | Description                                              |
| ------------ | ------------ | -------------------------------------------------------- |
| `public_key` | `string(68)` | Validator public key represented as a hexadecimal string |
| `era_id`     | `uint32`     | Era identifier                                           |
| `score`      | `float64`    | Validator performance score for the era                  |

**Example**

```json
{
  "public_key": "01e8121a2586a6add8a65990080633adfa4e0d32088d36d7fb6f6d3ede1bd7b823",
  "era_id": 12013,
  "score": 100
}
```

## Optional properties

None

## Relations

| Entity                                      | Mapping property | Description                       |
| ------------------------------------------- | ---------------- | --------------------------------- |
| [`Validator`](/1.3.x/rest-api/validator.md) | `public_key`     | Validators have performance score |

## Endpoints

The `ValidatorPerformance` entity has the following endpoints:

* [Get historical validator performance](/1.3.x/rest-api/validator-performance/get-historical-validator-performance.md)
* [Get historical average validator performance](/1.3.x/rest-api/validator-performance/get-historical-average-validator-performance.md)
* [Get historical average validators performances](/1.3.x/rest-api/validator-performance/get-historical-average-validators-performance.md)

## Relation endpoints

None


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.cspr.cloud/1.3.x/rest-api/validator-performance.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
